CGAL 6.2 - 3D Mesh Generation: CGAL::Mesh_facet_criteria_3< Tr > Class Template Reference

CGAL 6.2 - 3D Mesh Generation

Loading...
Searching...
No Matches
List of all members | Public Member Functions
CGAL::Mesh_facet_criteria_3< Tr > Class Template Reference
Reference Manual » Mesh Classes

`#include <CGAL/Mesh_facet_criteria_3.h>`

## Definition

template<typename Tr>
class CGAL::Mesh_facet_criteria_3< Tr >

The class `Mesh_facet_criteria_3` is a model of `MeshFacetCriteria_3`.

It provides a uniform bound for the shape criterion, a uniform or variable sizing field for the size criterion and/or a uniform or variable distance field for the approximation error criterion.

Template Parameters

  Tr | must be identical to the nested type `Triangulation` of the instance used as model of `MeshComplex_3InTriangulation_3`.

Is model of
  `MeshFacetCriteria_3`

See also
  `MeshCriteria_3`
  `MeshFacetCriteria_3`
  `MeshDomainField_3`
  `CGAL::Mesh_facet_topology`
  `CGAL::Mesh_criteria_3<Tr>`
  `CGAL::make_mesh_3()`

## Public Member Functions
Is_facet_bad | operator() (const Tr &tr, const Facet &facet) const
| returns whether the facet `facet` is bad or not.
std::optional< FT > | squared_min_radius_bound () const

## Types
typedef Tr::Geom_traits::FT | FT
| Numerical type.

## Creation
| Mesh_facet_criteria_3 (const FT &angle_bound, const FT &radius_bound, const FT &distance_bound, const Mesh_facet_topology topology=FACET_VERTICES_ON_SURFACE, const FT &min_radius_bound=0.)
| returns an object to serve as criteria for facets.
template<typename SizingField , typename DistanceField >
| Mesh_facet_criteria_3 (const FT &angle_bound, const SizingField &radius_bound, const DistanceField &distance_bound, const Mesh_facet_topology topology=FACET_VERTICES_ON_SURFACE, const FT &min_radius_bound=0.)
| Returns an object to serve as criteria for facets.

## Constructor & Destructor Documentation

## ◆ Mesh_facet_criteria_3() [1/2]

template<typename Tr >

CGAL::Mesh_facet_criteria_3< Tr >::Mesh_facet_criteria_3 | ( | const FT & | angle_bound,
|  | const FT & | radius_bound,
|  | const FT & | distance_bound,
|  | const Mesh_facet_topology | topology = `FACET_VERTICES_ON_SURFACE`,
|  | const FT & | min_radius_bound = `0.`
| ) |  |

returns an object to serve as criteria for facets.

Parameters

  angle_bound | is the lower bound for the angles in degrees of the surface mesh facets.
  radius_bound | is a uniform upper bound for the radius of the surface Delaunay balls.
  distance_bound | is an upper bound for the center-center distances of the surface mesh facets.
  topology | is the set of topological constraints which have to be verified by each surface facet. See section Delaunay Refinement for further details.
  min_radius_bound | is a uniform lower bound for the radius of the surface Delaunay balls. Only facets with a radius larger than that bound will be refined.

Note
  If one parameter is set to 0, then its corresponding criterion is ignored.

## ◆ Mesh_facet_criteria_3() [2/2]

template<typename Tr >
template<typename SizingField , typename DistanceField >

CGAL::Mesh_facet_criteria_3< Tr >::Mesh_facet_criteria_3 | ( | const FT & | angle_bound,
|  | const SizingField & | radius_bound,
|  | const DistanceField & | distance_bound,
|  | const Mesh_facet_topology | topology = `FACET_VERTICES_ON_SURFACE`,
|  | const FT & | min_radius_bound = `0.`
| ) |  |

Returns an object to serve as criteria for facets.

The types `SizingField` and `DistanceField` must be models of the concept `MeshDomainField_3`. The behavior and semantic of the arguments are the same as above, except that the radius and distance bound parameters are functionals instead of constants.

## Member Function Documentation

## ◆ operator()()

template<typename Tr >

Is_facet_bad CGAL::Mesh_facet_criteria_3< Tr >::operator() | ( | const Tr & | tr,
|  | const Facet & | facet
| ) |  | const

returns whether the facet `facet` is bad or not.

Parameters

  tr | the triangulation within which `facet` lives
  facet | the facet

## ◆ squared_min_radius_bound()

template<typename Tr >

std::optional< FT > CGAL::Mesh_facet_criteria_3< Tr >::squared_min_radius_bound | ( |  | ) | const

Returns
  the squared value of minimal radius bound if it was set, and `std::nullopt` otherwise